=== debian/changelog ===
typedload (2.40-1) unstable; urgency=medium

  * New upstream release
  * Updated d/copyright file
  * Bump Standards-Version, no changes needed
  * Drop Rules-Requires-Root field
  * Drop Priority: optional

 -- Salvo 'LtWorf' Tomaselli <ltworf@debian.org>  Wed, 11 Feb 2026 09:35:07 +0100
