=== debian/control ===
Source: typedload
Section: python
Maintainer: Salvo 'LtWorf' Tomaselli <ltworf@debian.org>
Build-Depends:
 debhelper (>= 13),
 python3-all:any,
 dh-python,
 python3-setuptools,
 python3-attr,
 debhelper-compat (= 13),
 jdupes
Standards-Version: 4.7.3
Homepage: https://ltworf.codeberg.page/typedload/
Vcs-Browser: https://codeberg.org/ltworf/typedload
Vcs-Git: https://codeberg.org/ltworf/typedload.git

Package: python3-typedload
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Suggests: python3-typedload-doc
Description: Load and dump json-like data into typed data structures in Python3
 This module provides an API to load dictionaries and lists (usually loaded
 from json) into Python's NamedTuples, dataclass, sets, enums, and various
 other typed data structures; respecting all the type-hints and performing
 type checks or casts when needed.
 .
 It can also dump from typed data structures to json-like dictionaries and
 lists.
 .
 It is very useful for projects that use Mypy and deal with untyped data like
 json, because it guarantees that the data will follow the desired schema.

Package: python3-typedload-doc
Architecture: all
Section: doc
Recommends: python3-typedload
Replaces: python3-typedload (<< 2.15-3)
Breaks: python3-typedload (<< 2.15-3)
Depends: ${mkdocs:Depends}, ${misc:Depends}
Description: Documentation and examples for python3-typedload
 This module provides an API to load dictionaries and lists (usually loaded
 from json) into Python's NamedTuples, dataclass, sets, enums, and various
 other typed data structures; respecting all the type-hints and performing
 type checks or casts when needed.
 .
 It can also dump from typed data structures to json-like dictionaries and
 lists.
 .
 It is very useful for projects that use Mypy and deal with untyped data like
 json, because it guarantees that the data will follow the desired schema.
 .
 This is the documentation for the module.
